/**
***     mathapp.hpp
***
***     Copyright (C) 2006 - 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#ifndef __MATHAPP_HPP
#define __MATHAPP_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFRESPONDER(RandomFrame)
class RandomFrame : public SFZTitleFlatFrame {
    SFMSEALRESPONDER(RandomFrame)
    SFMRESPONDERINSTANTIATEFOUR(RandomFrame, SFZTitleFlatFrame, SFYFrame, SFYWidget, SFYResponder)

    private:
        UIntN _graph[256];
        UIntN _max;

    public:
                RandomFrame(SIntN algorithm, SIntN repeat) static_throws;
        virtual ~RandomFrame(Void);
        static  RandomFrameSmp NewInstance(SIntN algorithm, SIntN repeat, SFCErrorPtr exception = null);
    private:
        XANDLER_DECLARE_VOIDRENDER(OnRenderContent)
        XANDLER_DECLARE_BOOLEVENT(OnKey)
};

SFMTYPEDEFRESPONDER(SinFrame)
class SinFrame : public SFZTitleFlatFrame {
    SFMSEALRESPONDER(SinFrame)
    SFMRESPONDERINSTANTIATEFOUR(SinFrame, SFZTitleFlatFrame, SFYFrame, SFYWidget, SFYResponder)

    private:
        SIntN _algorithm;
        SIntN _division;
        SFZWindowSmp _window;

    public:
                SinFrame(SIntN algorithm, SIntN division) static_throws;
        virtual ~SinFrame(Void);
        static  SinFrameSmp NewInstance(SIntN algorithm, SIntN division, SFCErrorPtr exception = null);
    private:
        XANDLER_DECLARE_VOIDRENDER(OnRenderContent)
        XANDLER_DECLARE_BOOLEVENT(OnKey)
};


SFMTYPEDEFCLASS(mathapp)
class mathapp : public SFYApplication {
    SFMSEALCOPY(mathapp)
    private:
        SFZTitleFlatFrameSmp            _frame;
        SFZWindowSmp                    _window;
        SFZSingleTextLabelControlSmp    _labelRandom;
        SFZSingleTextLabelControlSmp    _labelSin;
        SFZSingleTextLabelControlSmp    _labelDivision;
        SFZComboBoxControlSmp           _comboxRandomAlgorithm;
        SFZComboBoxControlSmp           _comboxSinAlgorithm;
        SFZSingleEditBoxControlSmp      _editboxRepeat;
        SFZSingleEditBoxControlSmp      _editboxDivision;
        SFZTextButtonControlSmp         _buttonRandom;
        SFZTextButtonControlSmp         _buttonSin;
        RandomFrameSmp                  _frameRamdom;
        SinFrameSmp                     _frameSin;
    public:
        static SFCInvokerPtr Factory(Void);
    private:
        explicit mathapp(Void) static_throws;
        virtual ~mathapp(Void);
        XANDLER_DECLARE_VOIDRESULT(OnRandomButtonControl)
        XANDLER_DECLARE_VOIDRESULT(OnSinButtonControl)
        XANDLER_DECLARE_VOIDRESULT(OnSinComboboxControl)
};

#endif // __MATHAPP_HPP //
